ssh-api
=======

Bash API for `ssh`, `scp` and `rsync`.

`host` command is required, considere install `dnsutils`.

```bash
sudo apt install dnsutils
```

## rsync-api.sh

Functions:

* `ssh_api_rsync_directory_from_host` ( `ssh_user` `ssh_host` `ssh_remote_dir` `local_directory` ):
TODOC

* `ssh_api_rsync_directory_locally` ( `source_directory` `destination_directory` ):
Use rsync to copy from a local directory to a other local directory

* `ssh_api_rsync_directory_to_host` ( `local_directory` `ssh_user` `ssh_host` `ssh_remote_dir` ):
Use rsync to copy from a local directory to a remote directory

* `ssh_api_rsync_file_from_host` ( `ssh_user` `ssh_host` `ssh_remote_file` `local_directory` ):
TODOC


## rsync-config-api.sh

Configuration helpers

### Configuration

* `RSYNC_CHECK_DESTINATION` : If set to `false` disable distination check before running rsync.
* `RSYNC_OPTS` : Allow to customize rsync calls (see man rsync)
* `RSYNC_RESOLV_HOST` : If set to `false`, don't try to resolv hostname to ip before running ssh.
* `SSH_API_RSYNC_DEBUG` : If set to `true` display rsync commands using `set -x`. (RSYNC_VERBOSE is deprecated)


## rsync-generic-main.sh

Functions:

* `ssh_api_rsync_generic_main` : TODOC


## scp-api.sh

Functions:

* `ssh_api_scp_to_host` ( `local_file` `ssh_user` `ssh_host` `ssh_remote_file` ):
Copy file using scp from local host to remote host

* `ssh_api_scp_from_host` ( `ssh_user` `ssh_host` `ssh_remote_file` `local_file` ):
Copy file using scp from remote host to local host

* `ssh_api_scp_directory_to_host` ( `local_directory` `ssh_user` `ssh_host` `ssh_remote_dir` ):
Copy directory using scp from local host to remote

### Configuration

* `SSH_API_SCP_OPTS` : Allow to customize scp calls (see man scp)
* `SSH_API_SCP_DEBUG` : If set to `true` display scp commands using `set -x`.


## ssh-api.sh

Functions:

* `ssh_api_do_ssh` ( `ssh_user` `ssh_host` `ssh_cmd` ):
TODOC

* `ssh_api_update_known_hosts` ( `host` ):
Add add remove any previous declarations of `host` to `~/.ssh/known_hosts`

* `ssh_api_update_known_hosts` ( `host` `key_type` ):
Add add remove any previous declarations of `host` to `~/.ssh/known_hosts`


## ssh-common-api.sh

Configuration:

* If `SSH_API_DISABLED_SSH_AGENT_AUTO_START` is set to `true` then don't run `ssh_api_start_ssh_agent` when sourcing file.
* If `SSH_API_DISABLED_SSH_AGENT_ADD_PRIVATE_KEY` is set to `true` then don't try to run `ssh-add` when sourcing file.
* `SSH_API_SSH_DEBUG` : If set to `true` display ssh extra debug lines.

Functions:

* `ssh_api_get_SSH_OPTS` (): Allow to customize ssh options using `SSH_API_SSH_OPTS` variable.
* `ssh_api_is_SSH_API_SSH_DEBUG` (): Check `SSH_API_SSH_DEBUG` value.

* `ssh_api_initialize_SSH_USER_or_exit` ( `ssh_host` ):
TODOC

* `ssh_api_test_remote_directory` ( `ssh_user` `ssh_host` `ssh_remote_dir` ):
TODOC

`ssh_api_start_ssh_agent` (): start ssh-agent if needed

